diff --git a/src/include/utils/commandtag.h b/src/include/utils/commandtag.h
new file mode 100644
index 0000000000..ab69c92d0a
--- /dev/null
+++ b/src/include/utils/commandtag.h
@@ -0,0 +1,248 @@
+/*-------------------------------------------------------------------------
+ *
+ * commandtag.h
+ *	  Declarations for commandtag names and enumeration.
+ *
+ * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/utils/commandtag.h
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef COMMANDTAG_H
+#define COMMANDTAG_H
+
+/*
+ * BEWARE: These are in sorted order, but ordered by their printed
+ *         values in the tag_name list (see common/commandtag.c).
+ *         In particular it matters because the sort ordering changes
+ *         when you replace a space with an underscore.  To wit:
+ *
+ *             "CREATE TABLE"
+ *             "CREATE TABLE AS"
+ *             "CREATE TABLESPACE"
+ *
+ *         but...
+ *
+ *             CREATE_TABLE
+ *             CREATE_TABLESPACE
+ *             CREATE_TABLE_AS
+ *
+ *         It also matters that COMMANDTAG_UNKNOWN is written "???".
+ *
+ * If you add a value here, add it in common/commandtag.c also, and
+ * be careful to get the ordering right.  You can build with
+ * COMMANDTAG_CHECKING to have this automatically checked
+ * at runtime, but that adds considerable overhead, so do so sparingly.
+ */
+typedef enum CommandTag
+{
+#define FIRST_COMMAND_TAG COMMANDTAG_UNKNOWN
+	COMMANDTAG_UNKNOWN,
+	COMMANDTAG_ALTER_ACCESS_METHOD,
+	COMMANDTAG_ALTER_AGGREGATE,
+	COMMANDTAG_ALTER_CAST,
+	COMMANDTAG_ALTER_COLLATION,
+	COMMANDTAG_ALTER_CONSTRAINT,
+	COMMANDTAG_ALTER_CONVERSION,
+	COMMANDTAG_ALTER_DATABASE,
+	COMMANDTAG_ALTER_DEFAULT_PRIVILEGES,
+	COMMANDTAG_ALTER_DOMAIN,
+	COMMANDTAG_ALTER_EVENT_TRIGGER,
+	COMMANDTAG_ALTER_EXTENSION,
+	COMMANDTAG_ALTER_FOREIGN_DATA_WRAPPER,
+	COMMANDTAG_ALTER_FOREIGN_TABLE,
+	COMMANDTAG_ALTER_FUNCTION,
+	COMMANDTAG_ALTER_INDEX,
+	COMMANDTAG_ALTER_LANGUAGE,
+	COMMANDTAG_ALTER_LARGE_OBJECT,
+	COMMANDTAG_ALTER_MATERIALIZED_VIEW,
+	COMMANDTAG_ALTER_OPERATOR,
+	COMMANDTAG_ALTER_OPERATOR_CLASS,
+	COMMANDTAG_ALTER_OPERATOR_FAMILY,
+	COMMANDTAG_ALTER_POLICY,
+	COMMANDTAG_ALTER_PROCEDURE,
+	COMMANDTAG_ALTER_PUBLICATION,
+	COMMANDTAG_ALTER_ROLE,
+	COMMANDTAG_ALTER_ROUTINE,
+	COMMANDTAG_ALTER_RULE,
+	COMMANDTAG_ALTER_SCHEMA,
+	COMMANDTAG_ALTER_SEQUENCE,
+	COMMANDTAG_ALTER_SERVER,
+	COMMANDTAG_ALTER_STATISTICS,
+	COMMANDTAG_ALTER_SUBSCRIPTION,
+	COMMANDTAG_ALTER_SYSTEM,
+	COMMANDTAG_ALTER_TABLE,
+	COMMANDTAG_ALTER_TABLESPACE,
+	COMMANDTAG_ALTER_TEXT_SEARCH_CONFIGURATION,
+	COMMANDTAG_ALTER_TEXT_SEARCH_DICTIONARY,
+	COMMANDTAG_ALTER_TEXT_SEARCH_PARSER,
+	COMMANDTAG_ALTER_TEXT_SEARCH_TEMPLATE,
+	COMMANDTAG_ALTER_TRANSFORM,
+	COMMANDTAG_ALTER_TRIGGER,
+	COMMANDTAG_ALTER_TYPE,
+	COMMANDTAG_ALTER_USER_MAPPING,
+	COMMANDTAG_ALTER_VIEW,
+	COMMANDTAG_ANALYZE,
+	COMMANDTAG_BEGIN,
+	COMMANDTAG_CALL,
+	COMMANDTAG_CHECKPOINT,
+	COMMANDTAG_CLOSE,
+	COMMANDTAG_CLOSE_CURSOR,
+	COMMANDTAG_CLOSE_CURSOR_ALL,
+	COMMANDTAG_CLUSTER,
+	COMMANDTAG_COMMENT,
+	COMMANDTAG_COMMIT,
+	COMMANDTAG_COMMIT_PREPARED,
+	COMMANDTAG_COPY,
+	COMMANDTAG_COPY_FROM,
+	COMMANDTAG_CREATE_ACCESS_METHOD,
+	COMMANDTAG_CREATE_AGGREGATE,
+	COMMANDTAG_CREATE_CAST,
+	COMMANDTAG_CREATE_COLLATION,
+	COMMANDTAG_CREATE_CONSTRAINT,
+	COMMANDTAG_CREATE_CONVERSION,
+	COMMANDTAG_CREATE_DATABASE,
+	COMMANDTAG_CREATE_DOMAIN,
+	COMMANDTAG_CREATE_EVENT_TRIGGER,
+	COMMANDTAG_CREATE_EXTENSION,
+	COMMANDTAG_CREATE_FOREIGN_DATA_WRAPPER,
+	COMMANDTAG_CREATE_FOREIGN_TABLE,
+	COMMANDTAG_CREATE_FUNCTION,
+	COMMANDTAG_CREATE_INDEX,
+	COMMANDTAG_CREATE_LANGUAGE,
+	COMMANDTAG_CREATE_MATERIALIZED_VIEW,
+	COMMANDTAG_CREATE_OPERATOR,
+	COMMANDTAG_CREATE_OPERATOR_CLASS,
+	COMMANDTAG_CREATE_OPERATOR_FAMILY,
+	COMMANDTAG_CREATE_POLICY,
+	COMMANDTAG_CREATE_PROCEDURE,
+	COMMANDTAG_CREATE_PUBLICATION,
+	COMMANDTAG_CREATE_ROLE,
+	COMMANDTAG_CREATE_ROUTINE,
+	COMMANDTAG_CREATE_RULE,
+	COMMANDTAG_CREATE_SCHEMA,
+	COMMANDTAG_CREATE_SEQUENCE,
+	COMMANDTAG_CREATE_SERVER,
+	COMMANDTAG_CREATE_STATISTICS,
+	COMMANDTAG_CREATE_SUBSCRIPTION,
+	COMMANDTAG_CREATE_TABLE,
+	COMMANDTAG_CREATE_TABLE_AS,
+	COMMANDTAG_CREATE_TABLESPACE,
+	COMMANDTAG_CREATE_TEXT_SEARCH_CONFIGURATION,
+	COMMANDTAG_CREATE_TEXT_SEARCH_DICTIONARY,
+	COMMANDTAG_CREATE_TEXT_SEARCH_PARSER,
+	COMMANDTAG_CREATE_TEXT_SEARCH_TEMPLATE,
+	COMMANDTAG_CREATE_TRANSFORM,
+	COMMANDTAG_CREATE_TRIGGER,
+	COMMANDTAG_CREATE_TYPE,
+	COMMANDTAG_CREATE_USER_MAPPING,
+	COMMANDTAG_CREATE_VIEW,
+	COMMANDTAG_DEALLOCATE,
+	COMMANDTAG_DEALLOCATE_ALL,
+	COMMANDTAG_DECLARE_CURSOR,
+	COMMANDTAG_DELETE,
+	COMMANDTAG_DISCARD,
+	COMMANDTAG_DISCARD_ALL,
+	COMMANDTAG_DISCARD_PLANS,
+	COMMANDTAG_DISCARD_SEQUENCES,
+	COMMANDTAG_DISCARD_TEMP,
+	COMMANDTAG_DO,
+	COMMANDTAG_DROP_ACCESS_METHOD,
+	COMMANDTAG_DROP_AGGREGATE,
+	COMMANDTAG_DROP_CAST,
+	COMMANDTAG_DROP_COLLATION,
+	COMMANDTAG_DROP_CONSTRAINT,
+	COMMANDTAG_DROP_CONVERSION,
+	COMMANDTAG_DROP_DATABASE,
+	COMMANDTAG_DROP_DOMAIN,
+	COMMANDTAG_DROP_EVENT_TRIGGER,
+	COMMANDTAG_DROP_EXTENSION,
+	COMMANDTAG_DROP_FOREIGN_DATA_WRAPPER,
+	COMMANDTAG_DROP_FOREIGN_TABLE,
+	COMMANDTAG_DROP_FUNCTION,
+	COMMANDTAG_DROP_INDEX,
+	COMMANDTAG_DROP_LANGUAGE,
+	COMMANDTAG_DROP_MATERIALIZED_VIEW,
+	COMMANDTAG_DROP_OPERATOR,
+	COMMANDTAG_DROP_OPERATOR_CLASS,
+	COMMANDTAG_DROP_OPERATOR_FAMILY,
+	COMMANDTAG_DROP_OWNED,
+	COMMANDTAG_DROP_POLICY,
+	COMMANDTAG_DROP_PROCEDURE,
+	COMMANDTAG_DROP_PUBLICATION,
+	COMMANDTAG_DROP_REPLICATION_SLOT,
+	COMMANDTAG_DROP_ROLE,
+	COMMANDTAG_DROP_ROUTINE,
+	COMMANDTAG_DROP_RULE,
+	COMMANDTAG_DROP_SCHEMA,
+	COMMANDTAG_DROP_SEQUENCE,
+	COMMANDTAG_DROP_SERVER,
+	COMMANDTAG_DROP_STATISTICS,
+	COMMANDTAG_DROP_SUBSCRIPTION,
+	COMMANDTAG_DROP_TABLE,
+	COMMANDTAG_DROP_TABLESPACE,
+	COMMANDTAG_DROP_TEXT_SEARCH_CONFIGURATION,
+	COMMANDTAG_DROP_TEXT_SEARCH_DICTIONARY,
+	COMMANDTAG_DROP_TEXT_SEARCH_PARSER,
+	COMMANDTAG_DROP_TEXT_SEARCH_TEMPLATE,
+	COMMANDTAG_DROP_TRANSFORM,
+	COMMANDTAG_DROP_TRIGGER,
+	COMMANDTAG_DROP_TYPE,
+	COMMANDTAG_DROP_USER_MAPPING,
+	COMMANDTAG_DROP_VIEW,
+	COMMANDTAG_EXECUTE,
+	COMMANDTAG_EXPLAIN,
+	COMMANDTAG_FETCH,
+	COMMANDTAG_GRANT,
+	COMMANDTAG_GRANT_ROLE,
+	COMMANDTAG_IMPORT_FOREIGN_SCHEMA,
+	COMMANDTAG_INSERT,
+	COMMANDTAG_LISTEN,
+	COMMANDTAG_LOAD,
+	COMMANDTAG_LOCK_TABLE,
+	COMMANDTAG_MOVE,
+	COMMANDTAG_NOTIFY,
+	COMMANDTAG_PREPARE,
+	COMMANDTAG_PREPARE_TRANSACTION,
+	COMMANDTAG_REASSIGN_OWNED,
+	COMMANDTAG_REFRESH_MATERIALIZED_VIEW,
+	COMMANDTAG_REINDEX,
+	COMMANDTAG_RELEASE,
+	COMMANDTAG_RESET,
+	COMMANDTAG_REVOKE,
+	COMMANDTAG_REVOKE_ROLE,
+	COMMANDTAG_ROLLBACK,
+	COMMANDTAG_ROLLBACK_PREPARED,
+	COMMANDTAG_SAVEPOINT,
+	COMMANDTAG_SECURITY_LABEL,
+	COMMANDTAG_SELECT,
+	COMMANDTAG_SELECT_FOR_KEY_SHARE,
+	COMMANDTAG_SELECT_FOR_NO_KEY_UPDATE,
+	COMMANDTAG_SELECT_FOR_SHARE,
+	COMMANDTAG_SELECT_FOR_UPDATE,
+	COMMANDTAG_SELECT_INTO,
+	COMMANDTAG_SET,
+	COMMANDTAG_SET_CONSTRAINTS,
+	COMMANDTAG_SHOW,
+	COMMANDTAG_START_TRANSACTION,
+	COMMANDTAG_TRUNCATE_TABLE,
+	COMMANDTAG_UNLISTEN,
+	COMMANDTAG_UPDATE,
+	COMMANDTAG_VACUUM
+#define LAST_COMMAND_TAG COMMANDTAG_VACUUM
+}			CommandTag;
+
+static inline bool
+PG_VALID_COMMANDTAG(CommandTag commandTag)
+{
+	return (commandTag >= FIRST_COMMAND_TAG &&
+			commandTag <= LAST_COMMAND_TAG);
+}
+
+extern const char *GetCommandTagName(CommandTag commandTag);
+extern CommandTag GetCommandTagEnum(const char *tagname);
+
+#endif							/* COMMANDTAG_H */
diff --git a/src/include/utils/plancache.h b/src/include/utils/plancache.h
index e48661ebec..04b02c083b 100644
--- a/src/include/utils/plancache.h
+++ b/src/include/utils/plancache.h
@@ -95,7 +95,7 @@ typedef struct CachedPlanSource
 	int			magic;			/* should equal CACHEDPLANSOURCE_MAGIC */
 	struct RawStmt *raw_parse_tree; /* output of raw_parser(), or NULL */
 	const char *query_string;	/* source text of query */
-	const char *commandTag;		/* command tag (a constant!), or NULL */
+	CommandTag	commandTag;
 	Oid		   *param_types;	/* array of parameter type OIDs, or NULL */
 	int			num_params;		/* length of param_types array */
 	ParserSetupHook parserSetup;	/* alternative parameter spec method */
@@ -186,10 +186,10 @@ extern void ResetPlanCache(void);
 
 extern CachedPlanSource *CreateCachedPlan(struct RawStmt *raw_parse_tree,
 										  const char *query_string,
-										  const char *commandTag);
+										  CommandTag commandTag);
 extern CachedPlanSource *CreateOneShotCachedPlan(struct RawStmt *raw_parse_tree,
 												 const char *query_string,
-												 const char *commandTag);
+												 CommandTag commandTag);
 extern void CompleteCachedPlan(CachedPlanSource *plansource,
 							   List *querytree_list,
 							   MemoryContext querytree_context,
diff --git a/src/include/utils/portal.h b/src/include/utils/portal.h
index 0b69433722..2365883acd 100644
--- a/src/include/utils/portal.h
+++ b/src/include/utils/portal.h
@@ -48,6 +48,7 @@
 
 #include "datatype/timestamp.h"
 #include "executor/execdesc.h"
+#include "utils/commandtag.h"
 #include "utils/plancache.h"
 #include "utils/resowner.h"
 
@@ -132,7 +133,8 @@ typedef struct PortalData
 
 	/* The query or queries the portal will execute */
 	const char *sourceText;		/* text of query (as of 8.4, never NULL) */
-	const char *commandTag;		/* command tag for original query */
+	CommandTag	commandTag;		/* command tag for original query */
+	QueryCompletionData	qcdata;	/* command completion data for executed query */
 	List	   *stmts;			/* list of PlannedStmts */
 	CachedPlan *cplan;			/* CachedPlan, if stmts are from one */
 
@@ -227,7 +229,7 @@ extern Portal GetPortalByName(const char *name);
 extern void PortalDefineQuery(Portal portal,
 							  const char *prepStmtName,
 							  const char *sourceText,
-							  const char *commandTag,
+							  CommandTag commandTag,
 							  List *stmts,
 							  CachedPlan *cplan);
 extern PlannedStmt *PortalGetPrimaryStmt(Portal portal);
diff --git a/src/include/utils/querycompletion.h b/src/include/utils/querycompletion.h
new file mode 100644
index 0000000000..b666e1fdc3
--- /dev/null
+++ b/src/include/utils/querycompletion.h
@@ -0,0 +1,60 @@
+/*-------------------------------------------------------------------------
+ *
+ * queryenvironment.h
+ *	  Access to functions to mutate the query environment and retrieve the
+ *	  actual data related to entries (if any).
+ *
+ * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/utils/queryenvironment.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef QUERYCOMPLETION_H
+#define QUERYCOMPLETION_H
+
+#include "utils/commandtag.h"
+
+typedef enum QueryCompletionDisplayFormat
+{
+	DISPLAYFORMAT_PLAIN,
+	DISPLAYFORMAT_NPROCESSED,
+	DISPLAYFORMAT_LAST_OID
+} QueryCompletionDisplayFormat;
+
+typedef struct QueryCompletionData
+{
+	CommandTag	commandTag;
+	uint64		nprocessed;
+	/* Wire-protocol backwards-compatibility hack */
+	QueryCompletionDisplayFormat	display_format;
+} QueryCompletionData;
+
+typedef QueryCompletionData *QueryCompletion;
+
+static inline void
+InitializeQC(QueryCompletionData *qc)
+{
+	qc->commandTag = COMMANDTAG_UNKNOWN;
+	qc->nprocessed = 0;
+	qc->display_format = DISPLAYFORMAT_PLAIN;
+}
+
+static inline void
+SetQC(QueryCompletionData *qc, CommandTag commandTag, uint64 nprocessed, QueryCompletionDisplayFormat display_format)
+{
+	qc->commandTag = commandTag;
+	qc->nprocessed = nprocessed;
+	qc->display_format = display_format;
+}
+
+static inline void
+CopyQC(QueryCompletionData *dst, const QueryCompletionData *src)
+{
+	dst->commandTag = src->commandTag;
+	dst->nprocessed = src->nprocessed;
+	dst->display_format = src->display_format;
+}
+
+#endif							/* QUERYCOMPLETION_H */
diff --git a/src/pl/plpgsql/src/pl_exec.c b/src/pl/plpgsql/src/pl_exec.c
index 5acf604f63..8a0f31b4b8 100644
--- a/src/pl/plpgsql/src/pl_exec.c
+++ b/src/pl/plpgsql/src/pl_exec.c
@@ -4115,10 +4115,9 @@ exec_stmt_execsql(PLpgSQL_execstate *estate,
 			 * tree(s), since those are the result of rewriting and could have
 			 * been transmogrified into something else entirely.
 			 */
-			if (plansource->commandTag &&
-				(strcmp(plansource->commandTag, "INSERT") == 0 ||
-				 strcmp(plansource->commandTag, "UPDATE") == 0 ||
-				 strcmp(plansource->commandTag, "DELETE") == 0))
+			if (plansource->commandTag == COMMANDTAG_INSERT ||
+				plansource->commandTag == COMMANDTAG_UPDATE ||
+				plansource->commandTag == COMMANDTAG_DELETE)
 			{
 				stmt->mod_stmt = true;
 				break;
diff --git a/src/test/modules/test_ddl_deparse/test_ddl_deparse.c b/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
index e1629ec618..d10c465a24 100644
--- a/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
+++ b/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
@@ -74,7 +74,7 @@ get_command_tag(PG_FUNCTION_ARGS)
 	if (!cmd->parsetree)
 		PG_RETURN_NULL();
 
-	PG_RETURN_TEXT_P(cstring_to_text(CreateCommandTag(cmd->parsetree)));
+	PG_RETURN_TEXT_P(cstring_to_text(GetCommandTagName(CreateCommandTag(cmd->parsetree))));
 }
 
 /*
-- 
2.21.1 (Apple Git-122.3)

